public class ChildCreature extends Creature implements Silence {

  DNA dna;
  Creature parent1, parent2;
  //  Oscil childModul, childCarrier;
  int sexPercMale, sexPercFem;  

  //to define the DNA of the child I will take the relative values of the sex from the parents DNA and sum them.
  //The higher value will be the sex of the child

  /*---------------CONSTRUCTOR---------------------*/

  ChildCreature( Creature pa1, Creature pa2) {

    println("--------------- NEW CHILD");
    parent1 = pa1;
    parent2 = pa2;
    //create a new DNA
    dna = new DNA();
    //setting the new  dna and physical parameters
    setDNA();
    setPhysical();
    setX(pa2.location.x + pa2.radius);
    setY(pa2.location.y + pa2.radius);


    //setting the new voice of the child
    setThisVoice();
    talk();
  }

  /*---------------RUN ---------------------*/

  /*
  void run() {
   //   super.run();
   modulate(childModul);//fucntion for the modulation of the fm
   } 
   */

  /*---------------set DNA---------------------*/

  void setDNA() {
    //    setParents(parent1, parent2);
    //defining the new sex
    defineChildSex();
    //setting the new sex percentage
    dna.setSexPerc(sexPercMale, sexPercFem);
    //    dna.defineGender();
    //setting the gender

    //we don't need these as it is already generated in the DNA
    //    dna.gender = dna.myGender[dna.genderType];
    //    //setting lifespan
    //    dna.lifespan = int(random(1, (30*100)));
  }


  /*---------------set PHYSICAL ATTR.---------------------*/

  void setPhysical() {

    //skin color
    float r, g, b;
    r = (red(parent1.skin))-(sides+dna.mutation);
    g = (green(parent2.skin))+(sides+dna.mutation);
    b = ((blue(parent1.skin)) + (blue(parent2.skin)))/(2);

    if (dna.mutation<=2) {
      skin = color (random(255), random(255), random(255));// here I am creating an exception in skin. If the mutation val is =<2 then the skin will be random.
    } else {
      //otherwise create skin with this rule
      skin = color ( r, g, b);// 
      //    skin = color ( 0, 255, 0);// full green used to test
      //    setSkin(skin);
    }
    //sides are a combination of the parents sides.
    sides = (parent1.sides - parent2.sides) + (int)randomGaussian()*dna.mutation/2 + (int)random(-1, 1);
    if (sides<3) {
      sides = 2 + dna.mutation;
    }
    //    setSides(sides);

    //radius are a combination of the parents radius.
    radius = (parent1.radius+parent2.radius)/2;
    //    setRadius(radius);

    //etnicity - if the etnicity of the parents is the same, the child gets the same etnicity (language) otherwise it will be a concatenated string (A+A+AE etc...)

    //if (parent1.etnicity==parent2.etnicity) {
    //  etnicity =  parent1.etnicity;
    //} else {
      etnicity = (parent1.etnicity+parent2.etnicity);
    //}
  }

  /*---------------set NEW VOICE---------------------*/

  void setThisVoice() {

    //limiting the range of modul and carrier
    int carrierRange = intoRange(int(random(parent1.sides*dna.mutation)), 20, 800);
    int modulRange = intoRange(int(random(parent2.sides*dna.mutation)), 20, 800);

    //    amp = map (dna.lifespan, 1,3000,0.0,0.5);

    // fma modulation for children with 2 etnicity letters (e.g. AE, BB etc..)
    if (etnicity.length()<2) {
      carrier = new Oscil( Frequency.ofPitch(parent2.etnicity + Integer.toString(carrierRange)), amp, Waves.TRIANGLE );//SETTING THE CARRIER

      /* // setup for the fm modulation W.i.p.
       childModul = new Oscil( Frequency.ofPitch(parent1.etnicity + Integer.toString(modulRange)), 0.5, Waves.SINE ); //setting the modulator
       childModul.offset.setLastValue(300);  //limiting the offset
       childModul.offset.setLastValue(this.sides*this.radius);
       childModul.patch(carrier.frequency);  //patching the 2 Oscil
       modulate(carrier);//fucntion for the modulation of the fm
       voice  = new Voice(carrier); ///create an object Voice with the Oscil carrier that is what we will hear
       */

      // if the etnicity comprehends more letters (e.g. BCB, ABD, etc...) use the sequencer
    } else { 
      setChildSpeech(80);
    }
  }


  /*---------------set NEW VOICE sequencer ---------------------*/

  void setChildSpeech( int tempo ) {
    //    //    /*

    voice.out.setTempo( tempo );
    voice.out.pauseNotes();

    int etnicityLength = etnicity.length();
    for (int i=0; i< etnicityLength; i++) {
      char note = etnicity.charAt(i);

      //limiting the values of the octave 
      //      int freqLimit = (int)map(random(sides-dna.mutation), 0, 100,4,8);
      //      int octaveRange = intoRange((parent2.sides + parent1.sides) / dna.mutation, 2, 8);
      int octaveRange = (int)map((parent2.sides + parent1.radius) / dna.mutation, 0, 100, 2, 32);

      String octave = Integer.toString(octaveRange);

      //startTime, duration, frequency
      voice.out.playNote(i, sides/radius, note + octave );
      println(note + octave);
    }
    //     */
  }

  /*---------------modulate for FM ---------------------*/

/*
  // modulate function helps for the fm modulation //not used in this version
  void modulate(Oscil fm)
  {
    float modulateAmount = map( location.x+1, 0, width, 220, 1 );
    float modulateFrequency = map( location.y+1, 0, height, 0.1, 100 );
    //    float modulateAmount = map( mouseY, 0, height, 220, 1 );
    //    float modulateFrequency = map( mouseX, 0, width, 0.1, 100 );

    fm.setFrequency( modulateFrequency );
    fm.setAmplitude( modulateAmount );
  }
  */

  /*----------------TALK-----------------*/

  void talk() {
    println("--------------TALK!");
    //    /*
    if (etnicity.length()<2) {
      carrier.patch(voice.out);
    } else { 
      //     */
      voice.out.resumeNotes();
    }
  }
  /*----------------silence-----------------*/

  //  /*
  void silence() {
    //    super.silence();
    carrier.unpatch(voice.out);
    //    childModul.unpatch(voice.out);
  }

  //  */
  /*---------------set PARENTS---------------------*/

  //let's define my parents
  void setParents(Creature pa1, Creature pa2) {

    parent1 = pa1;
    parent2 = pa2;
  }

  /*---------------DEFINE SEX---------------------*/

  //let's define my sex - summing the values of male and female of the parents. The higher will be the sex of the child
  String defineChildSex() {
    sexPercMale = parent1.dna.mySexPerc[0] +  parent2.dna.mySexPerc[0];
    sexPercFem = parent1.dna.mySexPerc[1] +  parent2.dna.mySexPerc[1];

    // check what's the higher value
    if (sexPercMale>sexPercFem + random(dna.mutation)) {
      dna.sex = dna.mySex[0];
    } else if (sexPercMale<sexPercFem - + random(dna.mutation) ) {
      dna.sex = dna.mySex[1];
    }

    //if the value are equal the sex is defined randomly
    if (sexPercMale==sexPercFem) {
      dna.sex = dna.mySex[(int)random(0, dna.mySex.length)];
    }

    return dna.sex;
  }

  /*---------------limit function ---------------------*/


  ////// limit function/////quick fucntion that allows me to limit some value;

  private int intoRange(int value, int min, int max) {
    return Math.min(Math.max(value, min), max);
  }
}